; 68040 access fault display version 0.3
;
;

	.include IOCSCALL.MAC
	.include DOSCALL.MAC


	.cpu	68040


PRINT	.macro	addr
	lea	addr,a1
	IOCS	_B_PRINT
	.endm

CRLF	.macro
	bsr	crlf
	.endm

		.offset	0
f_SR:		.ds.w	1	; 
f_PC:		.ds.l	1	; 
f_VEC:		.ds.w	1	; xN^ItZbg
f_EA:		.ds.l	1	; AhX
f_SSW:		.ds.w	1	; SSW
f_WB3S:		.ds.w	1	; 
f_WB2S:		.ds.w	1	; 
f_WB1S:		.ds.w	1	; 
f_FA:		.ds.l	1	; tH[gAhX
f_WB3A:		.ds.l	1	; 
f_WB3D:		.ds.l	1	; 
f_WB2A:		.ds.l	1	; 
f_WB2D:		.ds.l	1	; 
f_WB1A:		.ds.l	1	; 
f_LW0:		.ds.l	1	; 
f_LW1:		.ds.l	1	; 
f_LW2:		.ds.l	1	; 
f_LW3:		.ds.l	1	; 
		.text

top:
		.dc.l	-1
		.dc.w	$8000
		.dc.l	device_strategy
		.dc.l	device_interrupt
device_name:	.dc.b	'040*berr'

;------------------------------------------------------------
; ANZXtH[g
;------------------------------------------------------------
fault_save_regs	reg	d0-d7/a0-a6
New_berr:
		movem.l	fault_save_regs,-(sp)
		lea	((8+7)*4,sp),a6			; a6 = stack frame pointer

		move.w	(f_SSW,a6),d5
		bsr	stack_frame_disp
		bsr	berr_type_disp

		bfextu	d5{27:2},d6			; TT field
		beq	normal_access
		cmpi.b	#1,d6				; move16 access
		beq	move16_fault
		bra	nazo_berr

normal_access:	bfextu	d5{29:3},d7			; TM field (Function code)
		move.w	(TM_job_tbl,pc,d7.w*2),d0
		jmp	(TM_job_tbl,pc,d0.w)

TM_job_tbl:
		.dc.w	cache_push_error-TM_job_tbl	;0 data cache push
		.dc.w	normal_data_error-TM_job_tbl	;1 user data
		.dc.w	code_berr-TM_job_tbl		;2 user code
		.dc.w	nazo_berr-TM_job_tbl		;3 MMU table search data
		.dc.w	nazo_berr-TM_job_tbl		;4 MMU table search code
		.dc.w	normal_data_error-TM_job_tbl	;5 supervisor data
		.dc.w	code_berr-TM_job_tbl		;6 supervisor code
		.dc.w	nazo_berr-TM_job_tbl		;7 CPU space

nazo_berr:	PRINT	(m_nazo,pc)
berr_exit:	bsr	chk_frame_format
		movem.l	(sp)+,fault_save_regs
		moveq	#$ff,d0			;_ABORTJOB
		trap	#15
		jmp	([orig_berr,pc])		; Ƃ肠

orig_berr:	.ds.l	1
m_nazo:		.dc.b	'nazo error',13,10,0
		.even

;------------------------------------------------------------
; X^bNt[tH[}bǧ
;------------------------------------------------------------
chk_frame_format:
		cmpi.w	#$7008,(f_VEC,a6)
		bne	frame_error
		tst.b	(f_WB1S,a6)
		bne	frame_error
		tst.b	(f_WB2S,a6)
		bne	frame_error
		tst.b	(f_WB3S,a6)
		beq	@f
frame_error:	PRINT	(m_frame,pc)
@@:		rts

m_frame:	.dc.b	'stack frame format error!!',13,10,0
		.even

;------------------------------------------------------------
; MOVE16 ANZXG[
;------------------------------------------------------------
move16_fault:
		PRINT	(m_M16_f,pc)
		btst.l	#8,d5			; RW bit
		bne	@f
		bsr	lw_syori
@@:		bsr	wb_syori
		bra	berr_exit

m_M16_f:	.dc.b	'move16 access error',13,10,0
		.even

;------------------------------------------------------------
; f[^LbVEvbVtH[g
;------------------------------------------------------------
cache_push_error:
		btst.l	#8,d5			; RW bit
		bne	nazo_berr
		PRINT	(m_DCP_f,pc)
		bsr	lw_syori
		bsr	wb_syori
		bra	berr_exit

m_DCP_f:	.dc.b	'Data cache push fault',13,10,0
		.even

;------------------------------------------------------------
; m[}f[^EANZXG[
;------------------------------------------------------------
normal_data_error:
		PRINT	(m_NDA_f,pc)
		bsr	wb_syori
		bra	berr_exit

m_NDA_f:	.dc.b	'Normal data access error',13,10,0
		.even

;------------------------------------------------------------
; ߂`sbtH[gƃoXG[
;------------------------------------------------------------
code_berr:
		btst.l	#10,d5			; ATC bit
		bne	@f
		PRINT	(m_ATC_f,pc)
@@:		bra	berr_exit

m_ATC_f:	.dc.b	'Instruction ATC fault',0
		.even

;------------------------------------------------------------
; oXG[̃^Cv\
;------------------------------------------------------------
m_BUS_f:	.dc.b	', BUS ERROR(Hardware error??)',0
m_page:		.dc.b	', Page fault',0
m_wp:		.dc.b	', Write protect',0
m_super:	.dc.b	', Supervisor protect',0
m_Mts:		.dc.b	', PTEST failed',0
m_ma:		.dc.b	', Miss align access, Next page fault',0
m_wf:		.dc.b	'WRITE',0
m_rf:		.dc.b	'READ',0
		.even
berr_type_disp:
		clr.l	d4
		btst.l	#8,d5			; RW bit
		bne	rd_fault
		PRINT	(m_wf,pc)
		bra	@f
rd_fault:	PRINT	(m_rf,pc)
@@:		btst.l	#11,d5			; MA bit
		beq	@f
		PRINT	(m_ma,pc)
		st	d4
@@:		moveq	#1,d2
		movec	d2,DFC
		movea.l	(f_FA,a6),a0
		ptestw	(a0)			; fault vT
		movec	MMUSR,d2

@@:		btst.l	#11,d2			; MMU table search error
		beq	@f
		PRINT	(m_Mts,pc)
		bra	9f

@@:		btst.l	#2,d2			; Write protect
		beq	@f
		btst.l	#8,d5			; Write??
		bne	@f
		PRINT	(m_wp,pc)
		st	d4

@@:		tst.b	d2			; Supervisor
		bpl	@f
		btst.b	#5,(f_SR,a6)		; Supervisor
		bne	@f
		PRINT	(m_super,pc)
		st	d4

@@:		btst.l	#0,d2			; Resident
		beq	@f
		tst.b	d4
		bne	9f
		PRINT	(m_BUS_f,pc)
		bra	9f

@@:		PRINT	(m_page,pc)

9:		CRLF
		rts

;------------------------------------------------------------
; vbVf[^
;------------------------------------------------------------
m_pd:		.dc.b	'  Line data:$',0
		.even

lw_syori:
		PRINT	(m_addr,pc)
		move.l	(f_FA,a6),d1
		bsr	hex8out
		PRINT	(m_pd,pc)
		lea	(f_LW0,a6),a5
		moveq	#4-1,d2
@@:		move.l	(a5)+,d1
		bsr	hex8out
		bsr	putspc
		dbra	d2,@b
		CRLF
		rts

;------------------------------------------------------------
; CgobNf[^
;------------------------------------------------------------
m_wb1:		.dc.b	'WB1 ',0
m_wb2:		.dc.b	'WB2 ',0
m_wb3:		.dc.b	'WB3 ',0
		.even
wb_syori:
		move.w	(f_WB1S,a6),d2
		tst.b	d2				; test Valid bit
		bpl	skip_wb1s
		lea	(m_wb1,pc),a1
		move.l	(f_WB1A,a6),d3
		move.l	(f_LW0,a6),d4
		bsr	wb_status_disp

skip_wb1s:	move.w	(f_WB2S,a6),d2
		tst.b	d2				; test Valid bit
		bpl	skip_wb2s
		lea	(m_wb2,pc),a1
		move.l	(f_WB2A,a6),d3
		move.l	(f_WB2D,a6),d4
		bsr	wb_status_disp

skip_wb2s:	move.w	(f_WB3S,a6),d2
		tst.b	d2				; test Valid bit
		bpl	skip_wb3s
		lea	(m_wb3,pc),a1
		move.l	(f_WB3A,a6),d3
		move.l	(f_WB3D,a6),d4
		bsr	wb_status_disp

skip_wb3s:	bra	berr_exit

;------------------------------------------------------------
; CgobNXe[^X\
;------------------------------------------------------------
m_addr:		.dc.b	'Address:$',0
m_data:		.dc.b	' Data:$',0
		.even
wb_status_disp:
		bfextu	d2{25:2},d1		; SIZE field
		cmpi.b	#%11,d1			; line attribute
		beq	9f			; C]̏ꍇ͖
		IOCS	_B_PRINT
		PRINT	(m_addr,pc)
		move.l	d3,d1
		bsr	hex8out
		PRINT	(m_data,pc)
		move.l	d4,d1
		bsr	hex8out
		bfextu	d2{25:2},d1		; SIZE field
		bsr	size_disp
		bfextu	d2{27:2},d1		; TT field
		bsr	type_disp
		bfextu	d2{29:3},d1		; TM field
		bsr	tm_disp
		CRLF
9:		rts

;------------------------------------------------------------
; X^bNt[̕\
;------------------------------------------------------------
LDISP	.macro
	IOCS	_B_PRINT
	move.l	(a5)+,d1
	bsr	hex8out
	CRLF
	.endm

WDISP	.macro
	IOCS	_B_PRINT
	move.w	(a5)+,d1
	bsr	hex4out
	CRLF
	.endm

BBDISP	.macro
	IOCS	_B_PRINT
	move.w	(a5)+,d1
	bsr	bin16out
	CRLF
	.endm

BDISP	.macro
	IOCS	_B_PRINT
	move.w	(a5)+,d1
	bsr	bin8out
	CRLF
	.endm

stack_frame_disp:
		CRLF
		lea	(a6),a5
		lea	(m_sr,pc),a1
		BBDISP	;m_sr
		LDISP	;m_pc
		WDISP	;m_vec
		LDISP	;m_ea
		BBDISP	;m_ssw

		moveq	#3-1,d2
@@:		BDISP	;m_wb3s, m_wb2s, m_wb1s
		dbra	d2,@b

		moveq	#6-1,d2
@@:		LDISP	;m_fa, m_wb3a, m_wb3d, m_wb2a, m_wb2d, m_wb1a
		dbra	d2,@b

		moveq	#4-1,d2
		bsr	slw_print
		CRLF

		lea	(-((8+7)*4),a6),a5
		moveq	#8-1,d2
		bsr	slw_print
		CRLF

		moveq	#7-1,d2
		bsr	slw_print

		movec	usp,d1
		bsr	hex8out
		bsr	putspc
		lea	(30*2,a6),a5	; X^bNt[̕𑫂
		move.l	a5,d1
		bsr	hex8out

		CRLF
		rts


slw_print:	IOCS	_B_PRINT
@@:		move.l	(a5)+,d1
		bsr	hex8out
		bsr	putspc
		dbra	d2,@b
		rts

m_sr:		.dc.b	'  SR:%',0
m_pc:		.dc.b	'  PC:$',0
m_vec:		.dc.b	' VEC:$',0
m_ea:		.dc.b	'  EA:$',0
m_ssw:		.dc.b	' SSW:%',0
m_wb3s:		.dc.b	'WB3S:%',0
m_wb2s:		.dc.b	'WB2S:%',0
m_wb1s:		.dc.b	'WB1S:%',0
m_fa:		.dc.b	'  FA:$',0
m_wb3a:		.dc.b	'WB3A:$',0
m_wb3d:		.dc.b	'WB3D:$',0
m_wb2a:		.dc.b	'WB2A:$',0
m_wb2d:		.dc.b	'WB2D:$',0
m_wb1a:		.dc.b	'WB1A:$',0
m_lw0:		.dc.b	'  LW:$',0
m_dreg:		.dc.b	'data:$',0
m_areg:		.dc.b	'addr:$',0
		.even

;------------------------------------------------------------
; SIZE, TT, TM field ̕񉻕\
;------------------------------------------------------------

size_disp:	PRINT	(m_size,pc)
		move.w	(size_table,pc,d1.w*2),d0
		lea	(m_long,pc,d0.w),a1
		bra	1f

type_disp:	PRINT	(m_tt,pc)
		move.w	(type_table,pc,d1.w*2),d0
		lea	(m_normal,pc,d0.w),a1
		bra	1f

tm_disp:	PRINT	(m_tm,pc)
		move.w	(tm_table,pc,d1.w*2),d0
		lea	(m_fc0,pc,d0.w),a1
1:		IOCS	_B_PRINT
		rts

size_table:	.dc.w	m_long-m_long
		.dc.w	m_byte-m_long
		.dc.w	m_word-m_long
		.dc.w	m_line-m_long

type_table:	.dc.w	m_normal-m_normal
		.dc.w	m_move16-m_normal
		.dc.w	m_alt_fc-m_normal
		.dc.w	m_ack-m_normal

tm_table:	.dc.w	m_fc0-m_fc0
		.dc.w	m_fc1-m_fc0
		.dc.w	m_fc2-m_fc0
		.dc.w	m_fc3-m_fc0
		.dc.w	m_fc4-m_fc0
		.dc.w	m_fc5-m_fc0
		.dc.w	m_fc6-m_fc0
		.dc.w	m_fc7-m_fc0

m_size:		.dc.b	' SIZE:',0
m_tt:		.dc.b	' TT:',0
m_tm:		.dc.b	' TM:',0

m_long:		.dc.b	'long',0
m_byte:		.dc.b	'byte',0
m_word:		.dc.b	'word',0
m_line:		.dc.b	'line',0

m_normal:	.dc.b	'normal',0
m_move16:	.dc.b	'move16',0
m_alt_fc:	.dc.b	'alternate logic function code',0
m_ack:		.dc.b	'acknowledge',0

m_fc0:		.dc.b	'data cache push',0
m_fc1:		.dc.b	'user data',0
m_fc2:		.dc.b	'user code',0
m_fc3:		.dc.b	'MMU table search data',0
m_fc4:		.dc.b	'MMU table search code',0
m_fc5:		.dc.b	'supervisor data',0
m_fc6:		.dc.b	'supervisor code',0
m_fc7:		.dc.b	'CPU space',0
		.even

;------------------------------------------------------------
; d1 PUi\
;------------------------------------------------------------
hex8out:	swap	d1
		bsr	hex4out
		swap	d1
hex4out:	ror.w	#8,d1
		bsr	hex2out
		rol.w	#8,d1
hex2out:	ror.w	#4,d1
		bsr	hex1out
		rol.w	#4,d1
hex1out:	movem.l	d0/d1,-(sp)
		andi.w	#$000F,d1
		move.b	(hextbl,pc,d1.w),d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0/d1
		rts
hextbl:		.dc.b	'0123456789ABCDEF'

;------------------------------------------------------------
; d1 Qi\
;------------------------------------------------------------
bin8out:	movem.l	d0-d3,-(sp)
		move.b	d1,d3
		moveq	#7,d2
bin_loop:	move.w	#'0',d1
		btst.l	d2,d3
		beq	@f
		move.w	#'1',d1
@@:		IOCS	_B_PUTC
		dbra	d2,bin_loop
		movem.l	(sp)+,d0-d3
		rts

bin16out:	move.l	d0,-(sp)
		ror.w	#8,d1
		bsr	bin8out
		move.l	d1,-(sp)
		move.w	#'_',d1
		IOCS	_B_PUTC
		move.l	(sp)+,d1
		ror.w	#8,d1
		bsr	bin8out
		move.l	(sp)+,d0
		rts

;------------------------------------------------------------
; 󔒕\
;------------------------------------------------------------
putspc:		movem.l	d0/d1,-(sp)
		moveq	#$20,d1
		IOCS	_B_PUTC
		movem.l	(sp)+,d0/d1
		rts

;------------------------------------------------------------
; 
;------------------------------------------------------------
crlf:		movem.l	d0/a1,-(sp)
		lea	(m_crlf,pc),a1
		IOCS	_B_PRINT
		movem.l	(sp)+,d0/a1
		rts
m_crlf:		.dc.b	13,10,0

keep_bottom:
;------------------------------------------------------------
; DOS KEEPPR 풓ł͂܂
;------------------------------------------------------------
		.even
		.cpu	68000
device_reqhead:
		.ds.l	1

device_strategy:
		move.l	a5,(device_reqhead)
		rts

device_interrupt:
		movem.l	d1-d7/a0-a6,-(sp)
		movea.l	(device_reqhead,pc),a5
		tst.b	(2,a5)
		beq	device_initialize
device_error_exit:
		move.w	#$5003,d0
device_exit:
		move.b	d0,(3,a5)
		lsr.w	#8,d0
		move.b	d0,(4,a5)
		movem.l	(sp)+,d1-d7/a0-a6
		rts

device_bottom:
;------------------------------------------------------------
; DEVICE o^ł͂܂
;------------------------------------------------------------

;------------------------------------------------------------
; MPU   68040 ̏ꍇ̂ d0 = 0 Ԃ
;------------------------------------------------------------
MPUcheck:	clr.l	d0
		cmpi.b	#4,($0CBC)
		beq	@f
		pea	(illegal_mpu,pc)
		DOS	_PRINT
		addq.l	#4,sp
		moveq	#-1,d0
@@:		rts

;------------------------------------------------------------
; foCXhCo
;------------------------------------------------------------
device_initialize:
		pea	(dev_message,pc)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	MPUcheck
		tst.l	d0
		bmi	device_error_exit

		lea	(New_berr,pc),a1
		moveq	#2,d1
		IOCS	_B_INTVCS
		move.l	d0,orig_berr

		move.l	#'BERR',(device_name+4)
		move.l	#device_bottom,(14,a5)
		clr.l	d0
		bra	device_exit

;------------------------------------------------------------
; R}hs
;------------------------------------------------------------
command_entry:
		suba.l	a1,a1
		IOCS	_B_SUPER
		move.l	d0,d6

		pea	(name,pc)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	MPUcheck
		tst.l	d0
		bmi	go_exit

		lea	(New_berr,pc),a1
		moveq	#2,d1
		IOCS	_B_INTVCS
		move.l	d0,(orig_berr)
		movea.l	d0,a0
		lea	(-(New_berr-device_name),a0),a0
		lea	(device_name,pc),a1
		cmpm.l	(a0)+,(a1)+
		bne	go_keep
		cmpm.l	(a1)+,(a0)+
		bne	go_keep

		lea	(-(device_name+8-top),a0),a0
		movea.l	(orig_berr-top,a0),a1
		moveq	#2,d1
		IOCS	_B_INTVCS

		pea	(-$f0,a0)
		DOS	_MFREE
		addq.l	#4,sp
		tst.l	d0
		bne	mfree_fail
		pea	(m_mfree_ok,pc)
		bra	kaijo_exit

mfree_fail:	pea	(m_mfree_fail,pc)
kaijo_exit:	DOS	_PRINT
		addq.l	#4,sp
go_exit:	movea.l	d6,a1
		IOCS	_B_SUPER
		DOS	_EXIT

go_keep:	pea	(m_keeppr_ok,pc)
		DOS	_PRINT
		addq.l	#4,sp
		movea.l	d6,a1
		IOCS	_B_SUPER
		clr.w	-(sp)
		pea	(keep_bottom-top).w
		DOS	_KEEPPR


dev_message:	.dc.b	13,10
name:		.dc.b	'68040 access fault display v0.3 by bisco',13,10,0
illegal_mpu:	.dc.b	'68040pȂ',13,10,0
m_keeppr_ok:	.dc.b	'풓',13,10,'oXG[łւ炳(E\',13,10,0
m_mfree_fail:	.dc.b	'sIҁ[',13,10,0
m_mfree_ok:	.dc.b	'܂',13,10,0

	.end	command_entry
